<ui:composition xmlns:a4j="http://richfaces.org/a4j" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <rich:messages globalOnly="true" styleClass="message"/>
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{objectClassesManager.filter.urlParameters}"/>
            <!--@formatter:off-->
            <script>
                updateUrl("globalForm:filterUrlParameters");
                jq162("#globalForm\\:filterUrlParameters").bind('change',
                        function () {
                            updateUrl("globalForm:filterUrlParameters");
                        });
            </script>
            <!--@formatter:on-->
            <s:div id="globalDiv">
                <h1>#{messages['net.ihe.gazelle.hpd.LDAPStructureObjectClasses']}</h1>
                <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                    <ui:param name="panel_id" value="objectClassesPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.hpd.ObjectClasses']}"/>
                    </ui:define>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.hpd.FindBelowTheListOfObjectClassesDefinedInOurLDAPD']}"/>

                    <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                        <ui:define name="panel_title">#{messages['gazelle.simu.SearchCriteria']}</ui:define>
                        <div class="row">
                            <div class="col-md-6">
                                <ui:include src="/filter/filter.xhtml">
                                    <ui:param name="filter" value="#{objectClassesManager.filter}"/>
                                    <ui:param name="filterId" value="name"/>
                                    <ui:param name="filterName" value="#{messages['net.ihe.gazelle.hpd.Name']}"/>
                                    <ui:param name="filterForm" value="globalForm"/>
                                </ui:include>
                            </div>
                            <div class="col-md-6">
                                <ui:include src="/filter/filter.xhtml">
                                    <ui:param name="filter" value="#{objectClassesManager.filter}"/>
                                    <ui:param name="filterId" value="oid"/>
                                    <ui:param name="filterName" value="#{messages['net.ihe.gazelle.simulators.OID']}"/>
                                    <ui:param name="filterForm" value="globalForm"/>
                                </ui:include>
                            </div>
                        </div>
                        <ui:define name="filter_buttons">
                            <a4j:commandLink title="#{messages['gazelle.common.button.Refresh']}"
                                             render="globalForm">
                                <s:span styleClass="gzl-icon-refresh"/>
                            </a4j:commandLink>

                            <a4j:commandLink actionListener="#{objectClassesManager.reset()}"
                                             title="#{messages['net.ihe.gazelle.hpd.ResetFilter']}" type="submit"
                                             execute="@this" render="globalForm">
                                <s:span styleClass="gzl-icon-times-circle"/>
                            </a4j:commandLink>
                        </ui:define>
                    </ui:decorate>
                    <rich:dataTable value="#{objectClassesManager.data}" var="oc"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="objectClassesTable"
                                    render="ds">
                        <g:column sortBy="#{'name'}" sortOrder="ascending">
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.hpd.Name']}"/>
                            </ui:define>
                            <a4j:commandLink value="#{oc.name}"
                                             actionListener="#{objectClassesManager.setSelectedObjectClass(oc)}"
                                             oncomplete="jq162('#objecClassDetails').modal('show');"
                                             render="objecClassDetailsForm">
                            </a4j:commandLink>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.simulators.OID']}"/>
                            </ui:define>
                            <h:outputText value="#{oc.oid}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.hpd.MandatoryAttributes']}"/>
                            </ui:define>
                            <rich:list value="#{oc.must}" var="mustItem" type="unordered">
                                <a4j:commandLink value="#{mustItem}"
                                                 actionListener="#{objectClassesManager.setSelectedAttributeType(mustItem)}"
                                                 oncomplete="jq162('#attributeDetails').modal('show');"
                                                 render=":attributeDetailsForm">
                                </a4j:commandLink>
                            </rich:list>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.hpd.OptionalAttributes']}"/>
                            </ui:define>
                            <rich:list value="#{oc.may}" var="mayItem" type="unordered">
                                <a4j:commandLink value="#{mayItem}"
                                                 actionListener="#{objectClassesManager.setSelectedAttributeType(mayItem)}"
                                                 oncomplete="jq162('#attributeDetails').modal('show');"
                                                 render=":attributeDetailsForm">
                                </a4j:commandLink>
                            </rich:list>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="objectClassesTable"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </ui:decorate>
            </s:div>
        </h:form>
        <ui:include src="/documentation/modalPanelAttributeDetails.xhtml">
            <ui:param name="attribute" value="#{objectClassesManager.selectedAttribute}"/>
        </ui:include>
        <ui:include src="/documentation/modalPanelObjectClassDetails.xhtml">
            <ui:param name="oc" value="#{objectClassesManager.selectedObjectClass}"/>
        </ui:include>
    </ui:define>
</ui:composition>
